
/** Projet 3ETI - CPE Lyon - 2011-2012 */

#ifndef _MODEL_HPP_
#define _MODEL_HPP_


//encapsulation dans le namespace cpe
namespace cpe
{

  /** \brief Model de composant pour la resolution de l'equation.

      Le modele est du type:
       a0 u + a1 u' + b2 u'' = b0 i + b1 i' + b2 i''
  */
  class model
  {
  public:

      // ******************************************************** //
      // Constructeur
      // ******************************************************** //

      /** \brief Constructeur par defaut */
      model();
      /** \brief Constructeur direct
          Permet la construction d'un model en appelant dans le code:
           model mon_model=model(a0,a1,a2,b0,b1,b2);
      */
      model(double a0,double a1,double a2,double b0,double b1,double b2);


      // ******************************************************** //
      // Acces
      // ******************************************************** //

      /** \brief renvoie a0 */
      const double& a0() const;
      /** \brief renvoie a1 */
      const double& a1() const;
      /** \brief renvoie a2 */
      const double& a2() const;
      /** \brief renvoie b0 */
      const double& b0() const;
      /** \brief renvoie b1 */
      const double& b1() const;
      /** \brief renvoie b2 */
      const double& b2() const;

  private:

      /** \brief sotckage interne des 6 valeurs */
      double data[6];

  };

}

#endif
