
/** Projet 3ETI - CPE Lyon - 2011-2012 */

#ifndef _SIGNAL_HPP_
#define _SIGNAL_HPP_

#include <vector>

namespace cpe
{
    /** \brief Classe contenant un signal echantillonne */
    class signal
    {
    public:

        // ******************************************************** //
        // Constructeur
        // ******************************************************** //

        /** \brief constructeur vide */
        signal();
        /** \brief constructeur directe */
        signal(const std::vector<double>& data,double dt);

        // ******************************************************** //
        // Acces aux elements du signal
        // ******************************************************** //

        /** \brief renvoie la taille du signal */
        unsigned int size() const;
        /** \brief renvoie l'element k du signal */
        const double& operator[](unsigned int k) const;
        /** \brief renvoie la période d'echantillonnage */
        const double& dt() const;

        // ******************************************************** //
        // Calcul sur les elements du signal 
        // ******************************************************** //
      
      /** \brief renvoie la valeur maximale d'un signal */
      double max_signal() const;


    private:

        /** \brief le signal stocké en interne */
        std::vector<double> data_interne;
        /** \brief la période d'echantillonnage stockée en interne */
        double dt_interne;
    };
}

#endif
